// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// AutoLock.cpp
//
// $Id: AutoLock.cpp,v 1.2 2002/02/26 06:59:40 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "AutoLock.h"

#include "ErrorManager.h"

//------------------------------------------------------------------------------

namespace xb {

//------------------------------------------------------------------------------

AutoLock::AutoLock(pthread_mutex_t* pLock, const std::string& strReferrer) :
	m_pLock(pLock),
	m_strReferrer(strReferrer)
{
	EM::I()->Noise() << m_strReferrer << ": waiting for lock" << endl;
	pthread_mutex_lock(m_pLock);
	EM::I()->Noise() << m_strReferrer << ": got lock" << endl;
}

//------------------------------------------------------------------------------

AutoLock::~AutoLock()
{
	EM::I()->Noise() << m_strReferrer << ": releasing lock" << endl;
	pthread_mutex_unlock(m_pLock);
}

//------------------------------------------------------------------------------

};

//------------------------------------------------------------------------------
