// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ButtonImg.h
//
// $Id: ButtonImg.h,v 1.1 2002/02/18 20:21:05 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __BUTTONIMG__
#define __BUTTONIMG__

//------------------------------------------------------------------------------

#include <gtk--/eventbox.h>
#include <gtk--/imageloader.h>
#include <gtk--/pixmap.h>

namespace xb {

//------------------------------------------------------------------------------

class ButtonImg : public Gtk::EventBox
{
	// Types
	// Variables
	private:
		Gtk::ImageLoader* m_pPixNormal;
		Gtk::ImageLoader* m_pPixOver;
		Gtk::ImageLoader* m_pPixDown;

		Gtk::Pixmap m_pixButton;
		
	// Methods
	public:
		ButtonImg(const std::string& strNormalFile,
				  const std::string& strOverFile,
				  const std::string& strDownFile);
		~ButtonImg();


		void SetFiles(const std::string& strNormalFile,
					  const std::string& strOverFile,
					  const std::string& strDownFile);
		
		void Dump();
		
		SigC::Signal0<void> clicked;
		
	private:
		int ButtonDown(GdkEventButton* pButton);
		int ButtonUp(GdkEventButton* pButton);
		int ButtonEnter(GdkEventCrossing* pEvent);
		int ButtonLeave(GdkEventCrossing* pEvent);
};

//------------------------------------------------------------------------------

};

#endif

//------------------------------------------------------------------------------
