// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ButtonImgToggle.h
//
// $Id: ButtonImgToggle.h,v 1.1 2002/02/18 20:21:05 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __BUTTONIMGTOGGLE__
#define __BUTTONIMGTOGGLE__

//------------------------------------------------------------------------------

#include <gtk--/eventbox.h>
#include <gtk--/imageloader.h>
#include <gtk--/pixmap.h>

namespace xb {

//------------------------------------------------------------------------------

class ButtonImgToggle : public Gtk::EventBox
{
	// Types
	// Variables
	private:
		Gtk::ImageLoader m_pixNormal;
		Gtk::ImageLoader m_pixOver;
		Gtk::ImageLoader m_pixDown;

		Gtk::Pixmap m_pixButton;

		bool m_bToggled;
		
	// Methods
	public:
		ButtonImgToggle(const std::string& strNormalFile,
						const std::string& strOverFile,
						const std::string& strDownFile);
		~ButtonImgToggle();

		void Dump();
		
		SigC::Signal0<void> toggled;

		bool IsToggled() { return m_bToggled; }
		void SetState(bool bToggled);
		
	private:
		int ButtonDown(GdkEventButton* pButton);
		// int ButtonUp(GdkEventButton* pButton);
		int ButtonEnter(GdkEventCrossing* pEvent);
		int ButtonLeave(GdkEventCrossing* pEvent);
};

//------------------------------------------------------------------------------

};

#endif

//------------------------------------------------------------------------------
