// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Log.h
//
// $Id: Log.h,v 1.2 2002/02/18 20:02:51 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __LOG__
#define __LOG__

//------------------------------------------------------------------------------

#include <string>

namespace xb {

//------------------------------------------------------------------------------

class Log
{
		// Constants
	public:
		enum LogLevel {
			NOISE,
			TRACE,
			WARNING,
			ERROR,
			NONE
		};
		// Variables
	private:
		static LogLevel s_nLogLevel;
		
		// Methods
	public:

	    static void Noise(const std::string& strMessage);
		static void Trace(const std::string& strMessage);
		static void Warn(const std::string& strMessage);
		static void Error(const std::string& strMessage);

		static void SetLevel(LogLevel nLevel);
};

//------------------------------------------------------------------------------

};

#endif

//------------------------------------------------------------------------------
