// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// LogStream.h
//
// $Id: LogStream.h,v 1.1 2002/02/26 07:00:03 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __LogStream__
#define __LogStream__

#include <iostream>
#include <streambuf.h>

namespace xb {

//------------------------------------------------------------------------------

class LogStream
{
	// Constants
	public:
		enum LogLevel {
			NOISE,
			TRACE,
			WARNING,
			ERROR,
			NONE
		};
		
	// Types
	// Variables
	private:
		int m_nLogLevel;
		filebuf* m_pFileBuf;
		ostream* m_pNullStream;
		bool m_bFileLine;
		
	// Methods
	public:
		LogStream();
		~LogStream();

		ostream& Noise() const;
		ostream& Trace() const;
		ostream& Warn() const;
		ostream& Error() const;

		void SetLevel(LogLevel nLevel) { m_nLogLevel = nLevel; }
		void SetFileLine(bool bOn) { m_bFileLine = bOn; }
};

//------------------------------------------------------------------------------

};

#endif

//------------------------------------------------------------------------------
