// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Pixmap.h
//
// $Id: Pixmap.h,v 1.1 2002/02/18 20:37:11 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Pixmap__
#define __Pixmap__

#include <gdk--/bitmap.h>
#include <gdk--/pixmap.h>
#include <string>

namespace xb {

//------------------------------------------------------------------------------

class Pixmap
{
	// Constants
	// Types
	// Variables
	private:
		Gdk_Pixmap m_Pixmap;
		Gdk_Bitmap m_Mask;

		int m_nWidth;
		int m_nHeight;
		
	// Methods
	public:
		Pixmap(const std::string& strFilename);
		~Pixmap();

		const Gdk_Pixmap& GetPixmap() const { return m_Pixmap; }
		const Gdk_Bitmap& GetMask() const { return m_Mask; }

		int GetWidth() const { return m_nWidth; }
		int GetHeight() const { return m_nHeight; }
};

//------------------------------------------------------------------------------

};

#endif

//------------------------------------------------------------------------------
