// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// String.cpp
//
// $Id: String.cpp,v 1.3 2002/02/26 06:59:40 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "String.h"

#include <algorithm>
#include <cctype>

namespace xb {

//------------------------------------------------------------------------------
/*
String::String(int n) :
	std::string()
{
	if (n < 0) {
		push_back('-');
		n = -n;
	}

	Convert(n);
}
*/
//------------------------------------------------------------------------------

std::string
String::Upper(const std::string& strIn)
{
	std::string strResult;

    // uppercase all characters
    transform(strIn.begin(), strIn.end(),
			  back_inserter(strResult), 
			  toupper);
	
	return strResult;
}

//------------------------------------------------------------------------------

std::string
String::Lower(const std::string& strIn)
{
	std::string strResult;

    // lowercase all characters
    transform(strIn.begin(), strIn.end(),
			  back_inserter(strResult),     
			  tolower);              
	
	return strResult;
}

//------------------------------------------------------------------------------

void
String::Convert(int n)
{
	if (n < 10) {
		push_back(n + '0');
		return;
	}

	int nRemainder = n % 10;

	Convert((n - nRemainder) / 10);

	push_back(nRemainder + '0');
}

//------------------------------------------------------------------------------

};

//------------------------------------------------------------------------------
