// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// InfoOgg.h
//
// $Id: InfoOgg.h,v 1.3 2002/02/18 09:21:56 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __InfoOgg__
#define __InfoOgg__

#include "Info.h"

#include <vorbis/codec.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class InfoOgg : public Info
{
	// Constants
	// Types
	// Variables
	private:
		bool m_bInitOK;
		
		int m_nSeconds;
		std::string m_strTitle;
		std::string m_strArtist;
		std::string m_strAlbum;
		std::string m_strTrack;
		
	// Methods
	public:
		InfoOgg();
		virtual ~InfoOgg();

		virtual bool CanReadFile(const xb::Filename& strFilename) const;

		virtual void Init(const xb::Filename& strFilename);
		
		virtual int GetSeconds() const;
		virtual void SetSeconds(int nSec);
		virtual std::string GetTitle() const;
		virtual void SetTitle(const std::string& s);
		virtual std::string GetArtist() const;
		virtual void SetArtist(const std::string& s);
		virtual std::string GetAlbum() const;
		virtual void SetAlbum(const std::string& s);
		virtual std::string GetTrack() const;
		virtual void SetTrack(const std::string& s);

		virtual void Save();
		
		virtual void Dump() const;

	private:
		std::string GetComment(vorbis_comment* pComment,
							   const std::string& strTag);
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
