// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// BSBuffer.h
//
// $Id: BSBuffer.h,v 1.1 2002/01/25 05:23:27 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __BSBuffer__
#define __BSBuffer__

#include "Frame.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class BSBuffer
{
	// Constants
	// Types
	protected:
		struct bitstream_info
		{
				int bitindex;
				unsigned char *wordpointer;
		};

	// Variables
	private:
		unsigned char bsspace[2][Frame::MAXFRAMESIZE + 512];
		unsigned char* bsbuf;
		unsigned char* bsbufold;
		int bsnum;

		int m_nSSize;
		int m_nFSizeOld;

		bitstream_info bsi;
		
	// Methods
	public:
		BSBuffer();
		~BSBuffer();

		void FlipInit();

		unsigned char* Get() { return bsbuf; }

		void SetSize(int nSize) { m_nSSize = nSize; }
		void SetOldSize(int nSize) { m_nFSizeOld = nSize; }

		unsigned long GetBits(int n);
		unsigned long GetBitsFast(int n);
		unsigned char Get1Bit();
		unsigned int GetBitOffset();
		unsigned long GetByte();
		void BackBits(int n);
		void SetPointer(long backstep);

		void SpaceReset();
		void Reset();
		void IncrWordPointer(int n);
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
