// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Layer2.h
//
// $Id: Layer2.h,v 1.2 2002/01/27 02:12:48 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Layer2__
#define __Layer2__

#include "Layer.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Frame;
class Output;
class PlayerInfo;

class Layer2 : public Layer
{
	// Constants
	// Types
	// Variables
	protected:
		static int grp_3tab[32 * 3];
		static int grp_5tab[128 * 3];
		static int grp_9tab[1024 * 3];

	// Methods
	public:
		Layer2(PlayerInfo* pInfo, Output* pOutput, Visualization* pVis,
			   unsigned char* pSample, int* pPoint, BSBuffer* pBuffer);
		virtual ~Layer2();

		virtual int Run(Frame* fr);

		virtual void Init(int nVal) {}

	private:
		void II_step_one(unsigned int *bit_alloc, int *scale, Frame *fr);
		void II_step_two(unsigned int *bit_alloc,
						 float fraction[2][4][SBLIMIT],
						 int *scale, Frame *fr, int x1);
		void II_select_table(Frame *fr);
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
