// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// PlayerInfo.h
//
// $Id: PlayerInfo.h,v 1.2 2002/01/27 02:12:49 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __PlayerInfo__
#define __PlayerInfo__

#include <glib.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class PlayerInfo
{
	// Constants
	// Types
	// Variables
	public:
		gint going, num_frames, eof, jump_to_time, eq_active;
		gint songtime;
		gdouble tpf;
		gfloat eq_mul[576];
		gboolean output_audio;
		gboolean first_frame;
		guint32 filesize;	/* Filesize without junk */
		int resolution;

	// Methods
	public:
		PlayerInfo();
		~PlayerInfo();
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
