// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// OutputOgg.h
//
// $Id: OutputOgg.h,v 1.5 2002/02/18 09:21:57 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __OutputOgg__
#define __OutputOgg__

#include <glib.h>
#include <ogg/ogg.h>
#include <stdio.h>
#include <vorbis/codec.h>

#include "Output.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class OutputOgg : public Output
{
	// Constants
	// Types
	// Variables
	private:
		FILE* m_pFile;
		AFormat m_nFormat;
		int m_nWritten;

		vorbis_info m_VI;
		vorbis_dsp_state m_VD;
		vorbis_block m_VB;
		ogg_stream_state m_OS;
		
		int m_nChannels;
		
	// Methods
	public:
		OutputOgg();
		~OutputOgg();

		virtual void Init();

		virtual void GetVolume(int& nLeft, int& nRight) {}
		virtual void SetVolume(int nLeft, int nRight) {}

		virtual bool Open(AFormat nFormat, int nRate, int nChannels,
						  int nTrack);
		virtual void Write(void* pData, int nLength);
		virtual void Close();
		virtual void Flush(int nTime) {}
		virtual void Pause(bool bPause) {}

		virtual bool BufferPlaying() { return false; }
		virtual int ElapsedTime();
		virtual guint64 WrittenTime() const { return 0; }
		virtual int BufferFreeAmt() { return 1000000; }

		virtual bool IsFileOutput() const { return true; }
		virtual std::string GetFileExtension() const { return ".ogg"; }

		virtual std::string GetLibName() const { return "outputogg"; }
		virtual std::string GetDescription() const {
			return "Ogg Vorbis encoding"; }
		
	private:
		// void ConvertBuffer(gpointer buffer, gint length);
		
		int WritePage(ogg_page* pPage);
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
