// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// BurnManager.cpp
//
// $Id: BurnManager.cpp,v 1.17 2002/03/09 19:14:08 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "BurnManager.h"

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <xb/ErrorManager.h>

#include "ThreadBurn.h"

//------------------------------------------------------------------------------

using xb::EM;

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

BurnManager::BurnManager() :
	m_pThread(NULL)
{
	
}

//------------------------------------------------------------------------------

BurnManager::~BurnManager()
{
	Cleanup();
}

//------------------------------------------------------------------------------

void
BurnManager::Burn(const SongList& listSongs, bool bNoAction)
{
	m_pThread = new ThreadBurn(listSongs, bNoAction);
	EM::I()->Warn() << "setting up thread connections." << endl;
	m_pThread->StatusUpdate.connect(StatusUpdate.slot());
	m_pThread->Done.connect(Done.slot());
	m_pThread->Start();
}

//------------------------------------------------------------------------------

void
BurnManager::Cleanup()
{
	EM::I()->Warn() << "BurnManager::Cleanup() called" << endl;
	delete(m_pThread);
}

//------------------------------------------------------------------------------

bool
BurnManager::CheckCapability(std::string& strMessage)
{
	return true;
}

//------------------------------------------------------------------------------

void
BurnManager::Cancel()
{
	Cleanup();
}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------

