// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ChoiceDialog.h
//
// $Id: ChoiceDialog.h,v 1.6 2002/02/18 08:55:58 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __ChoiceDialog__
#define __ChoiceDialog__

#include <gtk--/label.h>
#include <gtk--/button.h>
#include <gtk--/radiobutton.h>
#include <list>
#include <xb/XDialog.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class ChoiceDialog : public xb::XDialog
{
	// Constants
	// Types
	// Variables
	private:
		static ChoiceDialog* m_pThisInstance;
		Gtk::Label* m_pLabel;
		Gtk::Button* m_pButton;
		Gtk::RadioButton_Helpers::Group m_Group;
		std::list<Gtk::RadioButton*> m_listWidgets;
		
	// Methods
	public:
		static ChoiceDialog* Instance();

		void ClearChoices();
		void AddChoice(const std::string& strText);
		void SetText(const std::string& strText);

		SigC::Signal1<void, int> ChoiceDialogDone;
		
	protected:
		ChoiceDialog();

		void SendSignal();
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
