// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ConfigDialog.h
//
// $Id: ConfigDialog.h,v 1.16 2002/02/18 08:55:58 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __ConfigDialog__
#define __ConfigDialog__

#include <gtk--/adjustment.h>
#include <gtk--/entry.h>
#include <gtk--/notebook.h>
#include <gtk--/radiobutton.h>
#include <gtk--/scale.h>
#include <gtk--/text.h>
#include <list>

#include <xb/XDialog.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class ConfigDialog : public xb::XDialog
{
	// Constants
	// Types
	private:
		struct PluginRadio {
				Gtk::RadioButton* m_pRadio;
				std::string m_strLibName;
		};

		typedef std::list<PluginRadio> PluginRadioList;
		
	// Variables
	private:
		static ConfigDialog* m_pThisInstance;
		Gtk::Notebook m_Notebook;

		Gtk::Entry m_EntryBurnDevice;
		Gtk::Entry m_EntryBurnSpeed;
		Gtk::Entry m_EntryRipDevice;
		Gtk::Entry m_EntryRipSpeed;
		Gtk::Entry m_EntryBitrate;

		Gtk::RadioButton* m_pRadioPlaylistCaps;
		Gtk::RadioButton* m_pRadioPlaylistNormal;

		PluginRadioList m_PluginRadioList;

		Gtk::Adjustment m_adjEncoderQuality;
		Gtk::HScale m_scaleEncoderQuality;
		
	// Methods
	public:
		static ConfigDialog* Instance();

		SigC::Signal0<void> PlayerStressTest;
		SigC::Signal0<void> PlayerStressTestSeq;
		SigC::Signal0<void> BurnStressTest;
		SigC::Signal0<void> RipStressTest;
		
	protected:
		ConfigDialog();

	private:
		void SetAboutText(Gtk::Text* pText);
		void ButtonOK();
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
