// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Info.cpp
//
// $Id: Info.cpp,v 1.5 2002/02/26 19:30:27 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "Info.h"

#include <xb/ErrorManager.h>

//------------------------------------------------------------------------------

using xb::EM;

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

Info::Info() :
	m_bSaveNeeded(false)
{

}

//------------------------------------------------------------------------------

Info::~Info()
{
	if (m_bSaveNeeded) {
		EM::I()->Warn() << "Info being destroyed w/o saving..." << endl;
	}
}

//------------------------------------------------------------------------------

void
Info::Init(const xb::Filename& strFilename)
{
	m_strFilename = strFilename;
}

//------------------------------------------------------------------------------

void
Info::Dump() const
{
	EM::I()->Trace() << "Filename: " << m_strFilename << endl;
	EM::I()->Trace() << "Seconds: " << GetSeconds() << endl;
	EM::I()->Trace() << "Title: " << GetTitle() << endl;
	EM::I()->Trace() << "Artist: " << GetArtist() << endl;
	EM::I()->Trace() << "Album: " << GetAlbum() << endl;
	EM::I()->Trace() << "Track: " << GetTrack() << endl;
}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------
