// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// InfoDialog.h
//
// $Id: InfoDialog.h,v 1.7 2002/02/18 08:55:58 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __InfoDialog__
#define __InfoDialog__

#include <xb/XDialog.h>

#include <gtk--/clist.h>
#include <gtk--/entry.h>
#include <gtk--/notebook.h>

#include "Song.h"
#include "SourceTable.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class InfoDialog : public xb::XDialog
{
	// Constants
	// Types
	// Variables
	private:
		static InfoDialog* m_pThisInstance;
		Gtk::Notebook m_Notebook;

		Song m_Song;
		SourceTable::SourceType m_eSourceType;
		
		Gtk::Entry m_entryTitle;

		Gtk::CList m_clistGeneral;
		Gtk::CList m_clistDetail;
		
		Gtk::Entry m_entryTagArtist;
		Gtk::Entry m_entryTagAlbum;
		Gtk::Entry m_entryTagTrack;
		
	// Methods
	public:
		static InfoDialog* Instance();

		void SetSong(const Song& song, SourceTable::SourceType eType);

	protected:
		InfoDialog();

	private:
		void UpdateInfo();
		void ButtonOK();
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
