// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// MWState.h
//
// $Id: MWState.h,v 1.4 2002/02/18 21:00:30 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __MWState__
#define __MWState__

#include <gtk--/pixmap.h>
#include <xb/Pixmap.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class WidgetMsgWin;

class MWState
{
	// Constants
	// Types
	// Variables
	protected:
		WidgetMsgWin* m_pParent;
		int m_nPriority;

		int m_nScrollX;
		int m_nStep;
		int m_nProgressWidth;
		int m_nProgressHeight;
		int m_nProgressX;
		int m_nProgressY;

		xb::Pixmap m_pixEQButton;
		int m_nEQButtonX;
		int m_nEQButtonY;
		
	// Methods
	public:
		MWState(WidgetMsgWin* pParent);
		virtual ~MWState();

		virtual void Draw(Gdk_Pixmap* pPixmap) = 0;
		virtual bool NeedsDrawTimer() = 0;
		virtual void ButtonPress(int nX, int nY) = 0;
		
		int GetPriority() const { return m_nPriority; }

	protected:
		void DrawCenteredString(Gdk_Pixmap* pPixmap, const Gdk_GC& gc,
								std::string s);
		void DrawCenteredHString(Gdk_Pixmap* pPixmap, const Gdk_GC& gc,
								 std::string s, int nY, int nPadX);
		void DrawCenteredScrollString(Gdk_Pixmap* pPixmap, const Gdk_GC& gc,
									  const std::string& s, int nY);
		void DrawProgressBar(Gdk_Pixmap* pPixmap, float fPercentage);
		void DrawProgressBar(Gdk_Pixmap* pPixmap, int nX, int nY, int nWidth,
							 float fPercent);
		void DrawEQButton(Gdk_Pixmap* pPixmap);
		
		void SetColor(Gdk_GC& gc, int nRed, int nGreen, int nBlue);
		void GetFont(Gdk_Font& font);
		void ResetScroll();
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
