// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Player.cpp
//
// $Id: Player.cpp,v 1.12 2002/02/26 19:30:27 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "Player.h"

#include <sys/wait.h>
#include <xb/ErrorManager.h>

#include "System.h"

//------------------------------------------------------------------------------

using xb::EM;

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

Player::Player() :
	m_bPlaying(false),
	m_bPlayComplete(false)
{

}

//------------------------------------------------------------------------------

Player::~Player()
{
	// Stop();
}

//------------------------------------------------------------------------------

void
Player::Init(Output* pOutput, Visualization* pVis)
{
	EM::I()->Trace() << "in Player::Init" << endl;
	
	m_pOutput = pOutput;
	m_pVisualization = pVis;
}

//------------------------------------------------------------------------------

void
signal_play_complete(int n)
{
	if (System::GetPlayer() != NULL) {
		int nExitStatus;
		wait(&nExitStatus);
		EM::I()->Trace() << "Player signal_play_complete: (" <<
			nExitStatus << ")" << endl;
		System::GetPlayer()->PlayComplete();
	}
}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------
