// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// RipManager.cpp
//
// $Id: RipManager.cpp,v 1.25 2002/02/18 21:00:31 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "RipManager.h"

#include <sigc++/slot.h>
#include <xb/ErrorManager.h>

#include "RipperCD.h"
#include "ThreadRip.h"

//------------------------------------------------------------------------------

using xb::EM;

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

RipManager::RipManager() :
	m_pThread(NULL)
{

}

//------------------------------------------------------------------------------

RipManager::~RipManager()
{
	Cleanup();
}

//------------------------------------------------------------------------------

void
RipManager::Rip(const std::string& strDevice,
				const SongList& listSongs, bool bNoAction)
{
	m_pThread = new ThreadRip(strDevice, listSongs, bNoAction);
	m_pThread->StatusUpdate.connect(StatusUpdate.slot());
	m_pThread->Done.connect(Done.slot());
	m_pThread->Start();
}

//------------------------------------------------------------------------------

void
RipManager::Cleanup()
{
	delete(m_pThread);
}

//------------------------------------------------------------------------------

bool
RipManager::CheckCapability(std::string& strMessage)
{
	RipperCD ripper;
	return ripper.CheckCapability(strMessage);
}

//------------------------------------------------------------------------------

void
RipManager::Cancel()
{
	Cleanup();
}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------




