// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// RipperCD.h
//
// $Id: RipperCD.h,v 1.10 2002/02/13 20:05:43 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __RIPPERCD__
#define __RIPPERCD__

extern "C" {
#include <cdda_interface.h>
#include <cdda_paranoia.h>
}

#include <string>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Output;

//------------------------------------------------------------------------------

class RipperCD
{
	// Constants
	private:
		static const int OUTBUFSZ = 32*1024;

	// Types
	// Variables
	private:
		cdrom_drive* m_pDrive;
		cdrom_paranoia* m_pParanoia;

		int bw_fd;
		long bw_pos;
		char bw_outbuf[OUTBUFSZ];

		Output* m_pOutput;
		
	// Methods
	public:
		RipperCD();
		~RipperCD();

		bool Init(const std::string& strDevice, Output* pOutput);
		void DisplayTOC();
		std::string Rip(int nTrack);

		bool CheckCapability(std::string& strMessage);
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------


