// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// System.cpp
//
// $Id: System.cpp,v 1.6 2001/12/31 17:39:20 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "System.h"

#include "Controller.h"
#include "Library.h"
#include "Player.h"
#include "PlayListManager.h"
#include "PropList.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------
// Static Variables
//------------------------------------------------------------------------------

Player* System::s_pPlayer = NULL;
PlayListManager* System::s_pPlayListManager = NULL;
Library* System::s_pLibrary = NULL;
PropList* System::s_pPropList = NULL;
Controller* System::s_pController = NULL;

//------------------------------------------------------------------------------
// Static Methods
//------------------------------------------------------------------------------

Player*
System::GetPlayer()
{
	return s_pPlayer;
}

//------------------------------------------------------------------------------

void
System::SetPlayer(Player* pPlayer)
{
	s_pPlayer = pPlayer;
}

//------------------------------------------------------------------------------

PlayListManager*
System::GetPlayListManager()
{
	return s_pPlayListManager;
}

//------------------------------------------------------------------------------

void
System::SetPlayListManager(PlayListManager* pManager)
{
	s_pPlayListManager = pManager;
}

//------------------------------------------------------------------------------

Library*
System::GetLibrary()
{
	return s_pLibrary;
}

//------------------------------------------------------------------------------

void
System::SetLibrary(Library* pLibrary)
{
	s_pLibrary = pLibrary;
}

//------------------------------------------------------------------------------

PropList*
System::GetPropList()
{
	return s_pPropList;
}

//------------------------------------------------------------------------------

void
System::SetPropList(PropList* pPropList)
{
	s_pPropList = pPropList;
}

//------------------------------------------------------------------------------

Controller*
System::GetController()
{
	return s_pController;
}

//------------------------------------------------------------------------------

void
System::SetController(Controller* pController)
{
	s_pController = pController;
}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------


