// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Thread.h
//
// $Id: Thread.h,v 1.9 2002/01/25 05:23:47 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Thread__
#define __Thread__

#include <cc++/thread.h>

#include <sigc++/object.h>
#include <sigc++/signal_system.h>

//------------------------------------------------------------------------------

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Thread : public ost::Thread
{
	// Constants
	// Types
	// Variables
	protected:
		bool m_bActive;
		
	// Methods
	public:
		Thread();
		virtual ~Thread();

		bool IsActive() const { return m_bActive; }
		
		SigC::Signal0<void> Done;

		// static void sleep(unsigned int msec);
		static void usleep(unsigned int usec);
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
