// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// TitleBar.cpp
//
// $Id: TitleBar.cpp,v 1.2 2002/02/18 21:00:31 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include <config.h>

#include "TitleBar.h"

#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/table.h>
#include <xb/ButtonImg.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

TitleBar::TitleBar() :
	Gtk::EventBox()
{
	Gtk::HBox* pBox = manage(new Gtk::HBox());
	add(*pBox);
	
	Gtk::Table* pBTable = manage(new Gtk::Table(1, 1));
	xb::ButtonImg* pButtonShrink =
		manage(new xb::ButtonImg(INTERFACE_DATA_DIR "/shrink-up.xpm",
								 INTERFACE_DATA_DIR "/shrink-over.xpm",
								 INTERFACE_DATA_DIR "/shrink-down.xpm"));
	pBTable->attach(*pButtonShrink, 0, 1, 0, 1, GTK_FILL, GTK_FILL);
	pButtonShrink->clicked.connect(ButtonShrink.slot());
	pBox->pack_start(*pBTable, false, false, 10);


	Gtk::Label* pLabel = manage(new Gtk::Label(PACKAGE " v" VERSION));
	pBox->pack_start(*pLabel);
	
	add_events(GDK_BUTTON_PRESS_MASK | GDK_BUTTON_MOTION_MASK);
}

//------------------------------------------------------------------------------

TitleBar::~TitleBar()
{

}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------
